package mngr

import (
	"encoding/json"
	pb "github.com/hyperledger/fabric/protos/peer"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/common/interfaces/isystempreference"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"gitlab.smartblocklab.com/smartcontracts/common/model/preferenceCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/model/userCC"
)

type tests []struct {
	name       string
	manager    isystempreference.ISystemPreferenceManager
	requestsId *requests.Id
	model      *preferenceCC.Preference
	want       *preferenceCC.Preference
	willAdd    *preferenceCC.Preference
	wantErr    bool

	errDescription string
}

func mockInvokeUserCC(userID string, manager *chaincode.ManagerImpl, dbAdapter *chaincode.StubInterfaceAdapterDBMock) error {
	jsonResponse, _ := json.Marshal(userCC.User{UserID: userID})
	param, err := manager.PrepareInvokeChaincodeParam(invoke.UserChannel, invoke.UserCC, invoke.GetUserFunction, requests.Id{Id: userID})
	dbAdapter.On("InvokeChaincode", invoke.UserCC, param, invoke.UserChannel).Return(pb.Response{Status: 200, Payload: jsonResponse})
	return err
}
