package chaincode

import (
	"github.com/hyperledger/fabric/core/ledger/kvledger/txmgmt/version"
	"github.com/hyperledger/fabric/core/ledger/kvledger/txmgmt/statedb"
)

//Mock couchDB
type StubInterfaceAdapterDBMock struct {
	StubInterfaceAdapterMock
	DB statedb.VersionedDB
}

func (mock *StubInterfaceAdapterDBMock) GetState(key string) ([]byte, error) {
	value, err := mock.DB.GetState("", key)
	if err != nil {
		return nil, err
	}

	if value == nil {
		return nil, nil
	}

	return value.Value, err
}

// PutState
func (mock *StubInterfaceAdapterDBMock) PutState(key string, value []byte) error {
	//полследняя строка
	lasntHeight := version.NewHeight(1, 5)

	//обновление
	updateBatch := statedb.NewUpdateBatch()
	//1 параметр добавочный к таблице имя к базе, 2 ключ в базе, колекция, 4 последняя строка
	updateBatch.Put("", key, value, lasntHeight)
	err := mock.DB.ApplyUpdates(updateBatch, lasntHeight)

	if err != nil {
		return GlobalLogger.Error(err.Error())
	}
	return nil
}
