package systempreferenceCC

import (
	"github.com/pkg/errors"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
)

type CryptoCurrencyFlag struct {
	CurrencyType string `json:"currency_type"`
	Enabled      bool   `json:"enabled"`
}

type EnabledCryptoCurrencyList struct {
	Flags []CryptoCurrencyFlag `json:"flags"`
}

func (this EnabledCryptoCurrencyList) New() chaincode.ValidObject {
	return &EnabledCryptoCurrencyList{}
}

func (this EnabledCryptoCurrencyList) CheckBeforeAdd(manager chaincode.IManager) error {
	return nil
}

func (this EnabledCryptoCurrencyList) CheckBeforeUpdate(updatedObject chaincode.ValidObject, manager chaincode.IManager) error {
	return nil
}

func (this EnabledCryptoCurrencyList) GetKey(manager chaincode.IManager) []string {
	return []string{EnabledCryptoCurrenciesKey}
}

func (this EnabledCryptoCurrencyList) Validate() error {
	if len(this.Flags) == 0 {
		return errors.New("Flags is empty")
	}

	for _, v := range this.Flags {
		if len(v.CurrencyType) == 0 {
			return errors.New("cryptoCurrencyFlag.CurrencyType is empty")
		}
	}

	return nil
}
