package nums

const ZeroAsset = "ZEROASSET"
const ErrorAssset = "ERRORASSET"

var btc, _ = NewAsset("BTC", 8, "21000000", "0.00000001")
var eth, _ = NewAsset("ETH", 18, "-1", "0.000000000000000001")
var xrp, _ = NewAsset("XRP", 8, "38622870411", "0.000001")
var bch, _ = NewAsset("BCH", 8, "21000000", "0.00000001")
var xem, _ = NewAsset("XEM", 7, "8999999999", "0.000001")
var ltc, _ = NewAsset("LTC", 8, "84000000", "0.00000001")
var dash, _ = NewAsset("DASH", 8, "18000000", "0.00000001")
var miota, _ = NewAsset("MIOTA", 0, "2777530283277760", "1")
var etc, _ = NewAsset("ETC", 18, "97261398", "0.000000000000000001")
var neo, _ = NewAsset("NEO", 18, "100000000", "0.000000000000000001")
var qtum, _ = NewAsset("QTUM", 18, "100000000", "0.000000000000000001")
var xmr, _ = NewAsset("XMR", 12, "18400000", "0.000000000001")
var strat, _ = NewAsset("STRAT", 15, "98502820", "0.000000000000001")
var bcc, _ = NewAsset("BCC", 8, "28000000", "0.00000001")
var waves, _ = NewAsset("WAVES", 8, "100000000", "0.00000001")
var zec, _ = NewAsset("ZEC", 8, "21000000", "0.00000001")
var zero, _ = NewAsset("ZEROASSET", 0, "0", "0")
var errAsset, _ = NewAsset("ERRORASSET", 0, "0", "0")

func AssetFrom(symbol string) *Asset {
	switch symbol {
	case "BTC":
		return btc
	case "ETH":
		return eth
	case "XRP":
		return xrp
	case "BCH":
		return bch
	case "XEM":
		return xem
	case "LTC":
		return ltc
	case "DASH":
		return dash
	case "MIOTA":
		return miota
	case "ETC":
		return etc
	case "NEO":
		return neo
	case "QTUM":
		return qtum
	case "XMR":
		return xmr
	case "STRAT":
		return strat
	case "BCC":
		return bcc
	case "WAVES":
		return waves
	case "ZEC":
		return zec
	case ZeroAsset:
		return zero
	default:
		return errAsset
	}
}
